
import java.math.BigInteger;

class java_mannwhitney_big {

  public static void main(String argv[]) {
    long size= Long.parseLong(argv[0]);
    long u= Long.parseLong(argv[1]);
    System.out.print(choose(size*2, size));
    System.out.println();
    System.out.print(nlimitchoices_b(size*2, size, u));
    System.out.println();
  }

  public static long choose(long n, long m) {
    if( m == 0 ) { return 1; }
    if( n <= 0 ) { return 0; }
    return choose(n-1, m-1) * n / m;
  }

  public static BigInteger nlimitchoices_b(long n, long m, long u) {
    BigInteger total;
    if( u < 0 ) { return BigInteger.ZERO; }
    if( m == 0 ) { return BigInteger.ONE; }
    total= BigInteger.ZERO;
    for( int d= 0; d<= n-m; ++d ) {
      total= total.add(nlimitchoices_b(n-d-1, m-1, u-m*d));
    }
    return total;
  }

  public static BigInteger nlimitchoices_b_i(long n, long m, long u) {
    if( n < m || u < 0 ) {
      return BigInteger.ZERO;
    }
    BigInteger num= BigInteger.ZERO;
    int[] st= new int[(int)m];
    int dind= 0;
    st[dind]= 0;
    while( dind >= 0 ) {
      while( m > 1 ) {
        ++dind;
        st[dind]= 0;
        --n;
        --m;
      }
      num= num.add(BigInteger.ONE);
      while( dind >= 0 ) {
        ++st[dind];
        --n;
        u -= m;
        if( n >= m && u >= 0 ) {
          break;
        }
        n += st[dind]+1;
        u += m*st[dind];
        ++m;
        --dind;
      }
    }
    return num;
  }

}

